c************************************************************
      SUBROUTINE initpressure(parint,pardpr,PPRANK)
      include 'undefined.h'
      INTEGER mymalloc,ngx,ngy,jx,jy,ncycle,cycles,npre,npost
      INTEGER j,nn,nx,ny,nnx,nny,ifetch,dfetch,nres,relax_times,
     * relax_times_old,ncycle_old,printres,parint(100),PPRANK
      DOUBLE PRECISION mineps,maxeps,norm_old,pardpr(100)
      INCLUDE 'size.h'
      INCLUDE 'pointers.f'
      COMMON /cycling/ mineps,maxeps,cycles,ncycle,npre,npost,nres,
     * relax_times,norm_old,printres,relax_times_old,ncycle_old
C
      OMEGA=1.0d0
C     Initialize memory allocation scheme in mymalloc (mymalloc.f) 
      mem=0
C
      nx = parint(1)
      ny = parint(2)
      WRITE(6,*)'PPRANK= ',PPRANK,' NX= ',nx
      WRITE(6,*)'PPRANK= ',PPRANK,' NY= ',ny
      cycles = parint(4)
      nres = parint(5)
      printres = parint(6)
      relax_times = parint(7)
      mineps = pardpr(9)
      ncycle=cycles
      nn=min(nx,ny)
c      write(6,*) 'MG_cycles_bound = ',ncycle  
c      write(6,*) 'div_tolerance = ',mineps
c      write(6,*) 'printres = ',printres
c      write(6,*) 'relax_times = ',relax_times
c      write(6,*) 'nres = ',nres
c
C     compute ng 
c
      j = nn - 2
      jx= nx-2
      jy= ny-2
      ng=1
      ngx=1
      ngy=1
 1    if(j.gt.2) then
         j = j/2
         ng = ng+ 1
         go to 1
      endif
      if((2**ng + 2).ne.nn ) then
         write(6,*)'nn=',nn,'   ng=',ng
         stop 'initpessure: nn.ne. 2**ng + 2'
      endif
 2    if(jx.gt.2) then 
         jx = jx/2
         ngx = ngx+ 1
         go to 2
      endif
      if((2**ngx + 2).ne.nx ) then 
         write(6,*)'nx=',nx,'   ngx=',ngx
         stop 'initpressure: nnx.ne. 2**ngx + 2'
      endif
 3    if(jy.gt.2) then
         jy = jy/2
         ngy = ngy+ 1
         go to 3
      endif
      if((2**ngy + 2).ne.ny ) then
         write(6,*)'ny=',ny,'   ngy=',ngy
         stop 'initpressure: ny.ne. 2**ngy + 2'
      endif
C      write (6,*) 'ngx =', ngx
C      write (6,*) 'ngy =', ngy
      WRITE(6,*)'PPRANK= ',PPRANK,' NG= ',NG
C
      nnx=nx
      nny=ny
      do j=ng,1,-1
         icc(j) = mymalloc(nnx*nny)
         iu(j) = mymalloc(nnx*nny)
         ia(j) = mymalloc(nnx*nny)
         ic(j) = mymalloc(nnx*nny)
         iei(j) = mymalloc(nnx*nny)
         ib(j) = mymalloc(nnx*nny)
         id(j) = mymalloc(nnx*nny)
         ires(j) = mymalloc(nnx*nny)
         irhs(j) = mymalloc(nnx*nny)
         nnx=nnx/2+1
         nny=nny/2+1
      enddo
      return
      end
c************************************************************
      integer function mymalloc(len)
      include 'undefined.h'
      INTEGER len
      INCLUDE 'size.h'
      INCLUDE 'pointers.f'
      if(mem+len.gt.MEMLEN)  then 
         write(6,*) 'MEMLEN=',MEMLEN,'mem+len',mem+len
         STOP 'insufficient memory in mymalloc'
      endif
      mymalloc = mem +1
      mem = mem + len
      return
      END
c
c
c
c************************************************************
c   This subroutine inverts the pressure equation
c
c   ON INPUT:
c  
c   nx by ny double arrays:
c   ---------------------
c   irhs(ng):  initial right hand side (divergence field)
c   cc: concentrations or volume fractions of phase 1
c   a:  coefficients for equation on grid n, computed with "afromc"
c   c:  coefficients "   "
c   ei: coefficients inverse "  "
c
c   scalar parameters:
c   ------------------
c   r1, r2: parameters used by afromc.
c   nx,ny:      dimension of arrays
c   ncycle: number of cycles in Vcycle
c
c  ON OUTPUT:
c
c   everything the same, except
c
c   iu(ng):      contains the pressure 
c
      SUBROUTINE mglin(r1,r2,nx,ny,parint,pardpr,COMM2D)
C     uses addint copy fill0 interp relax resid rstrct slvsml afromc
      INCLUDE 'undefined.h'
      INCLUDE 'mpif.h'
      INTEGER nx,ny,nn,nnx,nny,ncycle,cycles,NPRE,NPOST,n,nres,ifetch
      INTEGER i,j,q,jcycle,jj,jpost,jpre,nfx,nfy,ngrid,relax_times,
     *  printres,relax_times_old,ncycle_old,parint(100),PPRANK,COMM2D,
     *  IERR00
      DOUBLE PRECISION r1, r2,PARDPR(100),norm_total
      DOUBLE PRECISION mineps,maxeps,normmean,norm,norm_old,conv_rate
      SAVE conv_rate
      COMMON /cycling/ mineps,maxeps,cycles,ncycle,npre,npost,nres,
     *relax_times,norm_old,printres,relax_times_old,ncycle_old
      INCLUDE 'size.h'
      INCLUDE 'pointers.f'
      INTEGER il,jl
      DATA conv_rate /0.5d0/
      nn=min(nx,ny)
      if((2**ng+2).ne.nn) then
           write(6,*) "nn=",nn,"nx=",nx,"ny=",ny,"ng=",ng
           stop "fmg: nn.ne.(2**ng+2)"
      endif
C
      ncycle = PARINT(4)
      PPRANK = PARINT(55)
      ngrid=NG
      nnx=nx
      nny=ny
      nfx=nnx
      nfy=nny
 1    if (nn.gt.4) then
         nn=nn/2 + 1
         nnx=nnx/2 + 1
         nny=nny/2+1
         ngrid = ngrid - 1
         call acfromac(z(ia(ngrid)),z(ic(ngrid)),
     *        z(iei(ngrid)),z(ia(ngrid+1)),z(ic(ngrid+1)),nnx,nny)
         go to 1
      endif
c
c     first copy previous solution at time t^n in a field d(NG)
c
      call copy(z(id(NG)),z(iu(NG)),nfx,nfy)
c      
c     then calculate the residual on the finest grid and put it in rhs(NG) so that 
c     we will actually relax on the error eq.  Ae=res.
c      
      call resid(z(ires(NG)),z(id(NG)),z(irhs(NG)),z(ia(NG)),
     *     z(ic(NG)),nfx,nfy,PARINT,PARDPR,COMM2D)
      call copy(z(irhs(NG)),z(ires(NG)),nfx,nfy)
      norm=normmean(z(irhs(NG)),nfx,nfy)
      CALL MPI_ALLREDUCE(norm,norm_total,1,
     *                   MPI_DOUBLE_PRECISION,MPI_SUM,COMM2D,IERR00)
      if (printres .eq. 1) then 
         write(6,*) "PPRANK= ",PPRANK," beginning MG"," res(mean)=",
     *      norm,"max number of cycles=",ncycle," norm_total",norm_total
      endif
c
c     if bad convergence rate at the end of last MG cycle, then increase the number of smoothing 
c     for the new cycle
c
      relax_times_old=relax_times
c      write(*,*) "relax_times before=",relax_times_old
      ncycle_old=cycles
      if (printres .eq. 1) then 
      write(6,*) "PPRANK= ",PPRANK," numb relax on fine grid=",
     *        relax_times," conv_rate =",conv_rate," norm_old=",norm_old
      endif
      do n=1,ncycle
c     write(6,*) "numero cycle",n
         if(norm_total.lt.mineps) then
            call copy(z(iu(NG)),z(id(NG)),nfx,nfy)
            call makebcpf(z(iu(NG)),PARINT,PARDPR,nfx,nfy)
	    CALL BUPDAT(z(iu(NG)),PARINT,PARDPR,NFX,NFY,COMM2D)
            cycles=MAX(n-1,1)
            if (printres .eq. 1) then 
               write(6,*) "PPRANK= ",PPRANK," mglin: return cycles=",
     *                     cycles," norm=",norm
            endif
c           write(*,*) "old residual norm=",norm_old
            conv_rate=norm/norm_old
            return
         endif
         if(printres.eq.1) then
           write(6,*) "PPRANK= ",PPRANK," debut V-cycle"," res(mean)=",
     *                  normmean(z(irhs(NG)),nfx,nfy)
         endif
         norm_old=norm
c           write(*,*) "DEBUG1:old residual norm=",norm_old
c
c     on fine grid relax on the error e(NG) with initial guess e(NG)=0
c
         call fill0(z(iu(NG)),nfx,nfy)
c
c     Now u contains the error (or correction) and not the solution anymore.
c
         do jj=NG,2,-1
c
c     compute 1 relaxation on the NGth grid, 2 on the NG-1th ... NG-1 on
c     the 2nd (if relax_times=1)
c
            NPRE=relax_times*(NG-jj+1)
c           write(*,*) "NPRE=",NPRE
            do jpre=1,NPRE
               call relax(z(iu(jj)),z(irhs(jj)),
     *              z(ia(jj)),z(ic(jj)),z(iei(jj)),
     *              nfx,nfy,OMEGA,PARINT,PARDPR,COMM2D)
c
c     we copy all residuals in rhs in order to use it later for the correction step 
c     (in addint)
c
            enddo
            call resid(z(ires(jj)),z(iu(jj)),z(irhs(jj)),
     *           z(ia(jj)),z(ic(jj)),nfx,nfy,PARINT,PARDPR,COMM2D)
            call copy(z(irhs(jj)),z(ires(jj)),nfx,nfy)
c      write(6,*) "descente relax num.",jpre,"res(mean)=",
c     * normmean(z(ires(jj)),nfx,nfy)                        
            nfx=nfx/2+1
            nfy=nfy/2+1
c      write(6,*) "toto descend"
            call rstrct(z(irhs(jj-1)),z(irhs(jj)),nfx,nfy,PARINT,PARDPR,
     *                  COMM2D)
            call fill0(z(iu(jj-1)),nfx,nfy)
         enddo
c      write(6,*) "toto est tout en bas"
         call slvsml(z(iu(1)),z(irhs(1)),z(ia(1)),z(ic(1)),z(iei(1)),
     *        nfx,nfy,OMEGA,PARINT,PARDPR,COMM2D)
c
         do jj=2,NG
            nfx=2*nfx-2
            nfy=2*nfy-2
c
c     Use res and temporary storage inside addint, b for storage of the defect, rhs contains 
c     the previous residuals
c
            call addint(z(iu(jj)),z(iu(jj-1)),z(ires(jj)),z(ib(jj)),
     *     z(irhs(jj)),z(ia(jj)),z(ic(jj)),nfx,nfy,PARINT,PARDPR,COMM2D)
c
c relax NPOST times with initial guess e=0
c
            call fill0(z(ib(jj)),nfx,nfy)
            NPOST=relax_times*(NG-jj+1)
            do jpost=1,NPOST
               call relax(z(ib(jj)),z(irhs(jj)),
     *              z(ia(jj)),z(ic(jj)),z(iei(jj)),
     *              nfx,nfy,OMEGA,PARINT,PARDPR,COMM2D)
c
c     calculate residual and copy its value in rhs for next V-cycle.
c
            enddo
            call update(z(iu(jj)),z(ib(jj)),nfx,nfy,PARINT,PARDPR,
     *                  COMM2D) 
            call resid(z(ires(jj)),z(ib(jj)),z(irhs(jj)),
     *           z(ia(jj)),z(ic(jj)),nfx,nfy,PARINT,PARDPR,COMM2D)
            call copy(z(irhs(jj)),z(ires(jj)),nfx,nfy)
c      write(6,*) "montee relax num.",jpost,"res(mean)=",
c     *           normmean(z(iu(jj)),nfx,nfy)            
         enddo         
c
c     update solution on finest grid id = id+iu
c
         call update(z(id(NG)),z(iu(NG)),nfx,nfy,PARINT,PARDPR,COMM2D)
c     write(6,*) "toto est en haut de nouveau"
         norm=normmean(z(irhs(NG)),nfx,nfy)
C
C... Compute the overall norm and store it in norm_total (Tony)
C
         CALL MPI_ALLREDUCE(norm,norm_total,1,
     *                   MPI_DOUBLE_PRECISION,MPI_SUM,COMM2D,IERR00)
C
         conv_rate=norm/norm_old
c
c end of V-cycle loop
c
      enddo
      if (printres .eq. 1) then 
         write(6,*) "PPRANK= ",PPRANK," mglin: ncycles is reached,
     *norm=",norm
      endif
c
c if bad convergence rate : increase the number of relaxations
c
         if (conv_rate .gt. 0.6) then 
            relax_times=relax_times + 1
         else if (conv_rate .lt. 0.1) then
            relax_times=max(relax_times-1,1)
         endif
         write(6,*) "PPRANK= ",PPRANK," DEBUG4:relax_times=",relax_times
c         write(6,*) "numb relax on fine grid=",relax_times,"conv_rate ="
c     *    ,conv_rate,"norm_old=",norm_old
c
c     update pressure field
c
      call copy(z(iu(NG)),z(id(NG)),nfx,nfy)
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(z(iu(NG)),PARINT,PARDPR,nfx,nfy)
      CALL BUPDAT(z(iu(NG)),PARINT,PARDPR,NFX,NFY,COMM2D)
c
      return
      end
c
c***********************************************************************
c
      SUBROUTINE rstrct(uc,uf,ncx,ncy,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER ncx,ncy,PARINT(100),COMM2D
      DOUBLE PRECISION uc(ncx,ncy),uf(2*ncx-2,2*ncy-2),PARDPR(100)
      INTEGER ic,if,jc,jf
      DO jc=2,ncy-1
         jf=2*jc-2
         do ic=2,ncx-1
            if = 2*ic - 2
            uc(ic,jc)= .25d0*(uf(if,jf) + uf(if+1,jf) 
     *         + uf(if,jf+1) + uf(if+1,jf+1))
         enddo
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(uc,PARINT,PARDPR,ncx,ncy)
      CALL BUPDAT(uc,PARINT,PARDPR,NCX,NCY,COMM2D)
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE interp(uf,uc,nfx,nfy,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER nfx,nfy,PARINT(100),COMM2D
      DOUBLE PRECISION uc(nfx/2+1,nfy/2+1),uf(nfx,nfy),PARDPR(100)
      INTEGER ic,if,jc,jf,ncx,ncy
c      
      ncx=nfx/2 + 1
      ncy=nfy/2 + 1
      do jc=2,ncy-1
        jf=2*jc-2
        do ic=2,ncx-1
          if=2*ic-2
            uf(if,jf) = uc(ic,jc)
            uf(if,jf+1) = uc(ic,jc)
            uf(if+1,jf) = uc(ic,jc)
            uf(if+1,jf+1) = uc(ic,jc)
        enddo
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(uf,PARINT,PARDPR,nfx,nfy)
      CALL BUPDAT(uf,PARINT,PARDPR,NFX,NFY,COMM2D)
c      
      return
      END
c
c***********************************************************************
c
      SUBROUTINE addint(uf,uc,res,error,rhs,a,c,nfx,nfy,PARINT,PARDPR,
     *                  COMM2D)
      include 'undefined.h'
      INTEGER nfx,nfy,PARINT(100),COMM2D
      DOUBLE PRECISION res(nfx,nfy),uc(nfx/2+1,nfy/2+1),uf(nfx,nfy)
      DOUBLE PRECISION error(nfx,nfy),rhs(nfx,nfy),a(nfx,nfy),c(nfx,nfy)
      DOUBLE PRECISION PARDPR(100)
      INTEGER i,j
c
c  interpolate the error from coarse to fine grid
c
      call interp(error,uc,nfx,nfy,PARINT,PARDPR,COMM2D)
c
c calculate the new residual with res(new)=res(old)-A*error
c
      call resid(res,error,rhs,a,c,nfx,nfy,PARINT,PARDPR,COMM2D)
      call copy(rhs,res,nfx,nfy)
c
c correct e(ngrid) with error = Interp(e(ngrid-1))
c
      do j=2,nfy-1
        do i=2,nfx-1
          uf(i,j)=uf(i,j)+error(i,j)
        enddo
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(uf,PARINT,PARDPR,nfx,nfy)
      CALL BUPDAT(uf,PARINT,PARDPR,NFX,NFY,COMM2D)
c      
      return
      END
c
c***********************************************************************
c
      SUBROUTINE slvsml(u,rhs,a,c,ei,nx,ny,OMEGA,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER ntop
      INTEGER j,nx,ny,PARINT(100),COMM2D
      DOUBLE PRECISION a(nx,ny),c(nx,ny),ei(nx,ny),PARDPR(100)
      DOUBLE PRECISION rhs(nx,ny),u(nx,ny),OMEGA
c
c The system is solved "exaclty" on coarsest grid using a great number of 
c relaxations : the work is small since the number of points is small.
c
      NTOP=50
      do j=1,NTOP
        call relax(u,rhs,a,c,ei,nx,ny,OMEGA,PARINT,PARDPR,COMM2D)
      enddo
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE relax(u,rhs,a,c,ei,nx,ny,OMEGA,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER nx,ny,PARINT(100),COMM2D
      DOUBLE PRECISION rhs(nx,ny),u(nx,ny),OMEGA,temp,PARDPR(100)
      DOUBLE PRECISION a(nx,ny),c(nx,ny),ei(nx,ny)
      INTEGER i, ipass, isw, j, jsw
      DOUBLE PRECISION h, h2
      h=1.d0/(nx-2)
      h2=h*h
      jsw=1
c
c Force periodicity in x direction
c:
      do ipass=1,2
C
C... Update borders for the MPI version (Tony)
C
         call makebcpf(u,PARINT,PARDPR,nx,ny)
	 CALL BUPDAT(u,PARINT,PARDPR,NX,NY,COMM2D)
         isw=jsw
         do j=2,ny-1
            do i=isw+1,nx-1,2
               temp = (a(i,j)*u(i+1,j)+ a(i-1,j)*u(i-1,j)
     *                + c(i,j)*u(i,j+1) + c(i,j-1)*u(i,j-1)
     *                - h2*rhs(i,j))*ei(i,j)
               u(i,j) = OMEGA*temp + (1.0d0 - OMEGA)*u(i,j)
            enddo
            isw=3-isw
         enddo
         jsw=3-jsw
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(u,PARINT,PARDPR,nx,ny)
      CALL BUPDAT(u,PARINT,PARDPR,NX,NY,COMM2D)
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE resid(res,u,rhs,a,c,nx,ny,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER nx,ny,PARINT(100),COMM2D
      DOUBLE PRECISION res(nx,ny),rhs(nx,ny),u(nx,ny),PARDPR(100)
      DOUBLE PRECISION a(nx,ny),c(nx,ny)
      INTEGER i,j
      DOUBLE PRECISION h,h2i,alpha
c
      h=1.d0/(nx-2)
      h2i=1.d0/(h*h)
c
      do j=2,ny-1
        do i=2,nx-1
          res(i,j)= - h2i*(a(i,j)*(u(i+1,j)-u(i,j))
     *              +a(i-1,j)*(u(i-1,j)-u(i,j))
     *              + c(i,j)*(u(i,j+1)-u(i,j)) 
     *              + c(i,j-1)*(u(i,j-1) - u(i,j))
     *              ) + rhs(i,j)
        enddo
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcresf(res,PARINT,PARDPR,nx,ny)
      CALL BUPDAT(res,PARINT,PARDPR,NX,NY,COMM2D)
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE copy(aout,ain,nx,ny)
      include 'undefined.h'
      INTEGER nx,ny
      DOUBLE PRECISION ain(nx,ny),aout(nx,ny)
      INTEGER i,j
c
      do j =1,ny
        do i=1,nx
          aout(i,j)=ain(i,j)
        enddo
      enddo
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE fill0(u,nx,ny)
      include 'undefined.h'
      INTEGER nx,ny
      DOUBLE PRECISION u(nx,ny)      
      INTEGER i,j
c
      do j=1,ny
        do i=1,nx
          u(i,j)=0.d0
        enddo
      enddo
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE store(u,nx,ny)
      include 'undefined.h'
      INTEGER nx,ny
      DOUBLE PRECISION u(nx,ny)
      INTEGER i,j
c
      print*,"store,nx,ny=",nx,ny
      do j=1,ny
        do i=1,nx
          write (20,*) u(i,j)
        enddo
      enddo
      stop
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE acfromac(a,c,ei,a2,c2,nx,ny)
      include 'undefined.h'
      INTEGER i,j,nx,ny
      DOUBLE PRECISION a(nx,ny),c(nx,ny),ei(nx,ny)
      DOUBLE PRECISION a2(2*nx-2,2*ny-2),c2(2*nx-2,2*ny-2)
c
         do j=2,ny-1
            do i=1,nx-1
               a(i,j) = 0.5d0*(a2(2*i-1,2*j-2)+a2(2*i-1,2*j-1))
            enddo
         enddo
c      
         do j=1,ny-1
            do i=2,nx-1
               c(i,j) = 0.5d0*(c2(2*i-2,2*j-1)+c2(2*i-1,2*j-1)) 
            enddo 
         enddo 
         do j=2,ny-1
            do i=2,nx-1
               ei(i,j) = 1.0d0/(a(i-1,j)+a(i,j)+c(i,j-1)+c(i,j))
            enddo 
         enddo 
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE eifromac(a,c,ei,r1,r2,nx,ny)
      include 'undefined.h' 
      INTEGER nx,ny 
      DOUBLE PRECISION a(nx,ny),c(nx,ny),ei(nx,ny) 
      DOUBLE PRECISION r1,r2 ,dmax1,dmin1,cc1,cc2,cc3 
      INTEGER i,j 
c 
      do j=2,ny-1 
         do i=2,nx-1 
             a(i,j) = 1.d0/(r1*a(i,j) + r2) 
             c(i,j) = 1.d0/(r1*c(i,j) + r2) 
          enddo 
      enddo 
c 
      do j=2,ny-1 
          a(1,j) = a(2,j) 
      enddo 
c 
      do j=2,nx-1 
          c(j,1) =  c(j,2) 
      enddo
c
      do j=2,ny-1
         do i=2,nx-1
             ei(i,j) = 1.d0/(a(i,j) + a(i-1,j) + c(i,j) + c(i,j-1))
         enddo
      enddo
c
      return
      end
c
c***********************************************************************
c
      SUBROUTINE update(aout,ain,nx,ny,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INTEGER nx,ny,PARINT(100),COMM2D
      DOUBLE PRECISION ain(nx,ny),aout(nx,ny),PARDPR(100)
      INTEGER i,j
c
      do j =2,ny-1
         do i=2,nx-1
            aout(i,j)=aout(i,j)+ain(i,j)
         enddo
      enddo
C
C... Update borders for the MPI version (Tony)
C
      call makebcpf(aout,PARINT,PARDPR,nx,ny)
      CALL BUPDAT(aout,PARINT,PARDPR,NX,NY,COMM2D)
c
      return
      END
c
c***********************************************************************
c
      SUBROUTINE writefield(u,nx,ny)
      include 'undefined.h'
      INTEGER nx,ny
      DOUBLE PRECISION u(nx,ny)
      INTEGER i,j
c
      do j =1,ny
         do i=1,nx
            write(6,*) "p",i,",",j,"=",u(i,j)
         enddo
      enddo
c
      return
      END
