      SUBROUTINE MAKEBCV(U,V,PARINT,PARDPR,INX,INY,COMM2D,T)
C
C     Author: Enrique LOPEZ-PAGES & Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the Velocity
C     Purpose: To define the type and place of boundary conditions.
C     Called by: momentum & time-step
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INCLUDE 'mpif.h'
      INTEGER NEIGHB(8),PARINT(100),INX,INY,
     &        PPRANK,INDIXF,INDIXL,INDIYF,INDIYL,INDI01,
     &        IERR00,COMM2D,T
      DOUBLE PRECISION PARDPR(100),OUTVAL,ROUTF1,ROUTF2,SOLID1,
     &                 VELFL1,VELFL2,XIPROC,XFPROC,
     &                 YIPROC,YFPROC,XDIST1,XDIST2,XDIST3,XDIST4,
     &                 XDIST5,XDIST6,OUTF00,OUTF11,
     &                 OUTF21,OFLUS1,OFLUS2,TMPFL1,NPROCX
      DOUBLE PRECISION U(INX,INY),V(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'USERBC'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
      OUTVAL = 0.D0
      OUTF11 = 0.D0
      OUTF21 = 0.D0
      TMPFL1 = 0.D0
      OFLUS1 = 0.D0
      OFLUS2 = 0.D0
      XDIST1 = -1.D0
      XDIST2 = 0.D0
      XDIST3 = 0.D0
      XDIST4 = 0.D0
      XDIST5 = -1.D0
      XDIST6 = 0.D0
      ROUTF1 = PARDPR(6)
      SOLID1 = PARDPR(7) + ROUTF1
      ROUTF2 = PARDPR(8) + SOLID1
      VELFL1 = PARDPR(10)
      VELFL2 = PARDPR(11)
      XIPROC = PARDPR(54)
      XFPROC = PARDPR(54) + PARDPR(52)
      YIPROC = PARDPR(55)
      YFPROC = PARDPR(55) + PARDPR(53)
      NPROCX = PARINT(51)
      IF (XIPROC.LT.ROUTF1) THEN
        XDIST1 = XIPROC
	IF (XFPROC.LE.ROUTF1) THEN
	  XDIST2 = XFPROC
	ELSEIF (XFPROC.LE.SOLID1) THEN
	  XDIST2 = ROUTF1
	ELSEIF (XFPROC.LE.ROUTF2) THEN
	  XDIST2 = ROUTF1
	  XDIST5 = SOLID1
	  XDIST6 = XFPROC
        ELSE
	  XDIST2 = ROUTF1
	  XDIST5 = SOLID1
	  XDIST6 = ROUTF2
	ENDIF
      ELSEIF (XIPROC.LT.SOLID1) THEN
	XDIST1 = -1.D0
	IF (XFPROC.LE.SOLID1) THEN
	  XDIST5 = -1.D0
	ELSEIF (XFPROC.LE.ROUTF2) THEN
          XDIST5 = SOLID1
	  XDIST6 = XFPROC
	ELSE
	  XDIST5 = SOLID1
	  XDIST6 = ROUTF2
	ENDIF
      ELSEIF (XIPROC.LT.ROUTF2) THEN
        XDIST5 = XIPROC
        IF (XFPROC.LE.ROUTF2) THEN
	  XDIST6 = XFPROC
	ELSE
	  XDIST6 = ROUTF2
	ENDIF
      ENDIF
c      WRITE(6,*)'RANK= ',PPRANK,' DELTAX = ',DELTAX
c      WRITE(6,*)'RANK= ',PPRANK,' DELTAT = ',DELTAT
c      WRITE(6,*)'RANK= ',PPRANK,' ROUTF1 = ',ROUTF1
c      WRITE(6,*)'RANK= ',PPRANK,' SOLID1 = ',SOLID1
c      WRITE(6,*)'RANK= ',PPRANK,' ROUTF2 = ',ROUTF2
c      WRITE(6,*)'RANK= ',PPRANK,' XIPROC = ',XIPROC
c      WRITE(6,*)'RANK= ',PPRANK,' XFPROC = ',XFPROC
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST1 = ',XDIST1
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST2 = ',XDIST2
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST3 = ',XDIST3
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST4 = ',XDIST4
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST5 = ',XDIST5
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST6 = ',XDIST6
C
C.... Start from South boundary (usually the more complex BC).
      IF(NEIGHB(5).LT.0) THEN
C.... Basic boundary condition.
c	WRITE(6,*)'RANK= ',PPRANK,' BC AT SOUTH'
	CALL MAKEBC(3,3,0,U,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
	CALL MAKEBC(3,3,1,U,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,3,0,V,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,3,1,V,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
C.... Inlet of Fluid 1.
	IF(XDIST1.GE.0.D0) THEN
c	  WRITE(6,*)'RANK= ',PPRANK,' LIQUID INLET AT SOUTH'
c	  WRITE(6,*)'RANK= ',PPRANK,' VELFL1= ',VELFL1
          CALL MAKEBC(1,3,0,V,VELFL1,0.D0,OUTF11,XDIST1,XDIST2,PARINT,
     &                PARDPR,PPRANK,INX,INY)
          CALL MAKEBC(1,3,1,V,VELFL1,0.D0,OUTVAL,XDIST1,XDIST2,PARINT,
     &                PARDPR,PPRANK,INX,INY)
	ENDIF
C
C.... Conditions for solid separator are imposed by "Basic BC".
C
C.... Inlet of Fluid 2.
c	IF(XDIST5.GE.0.D0) THEN
c          WRITE(6,*)'RANK= ',PPRANK,' GAS INLET AT SOUTH'
c	  WRITE(6,*)'RANK= ',PPRANK,' VELFL2= ',VELFL2
c	  CALL MAKEBC(1,3,0,V,VELFL2,0.D0,OUTF21,XDIST5,XDIST6,PARINT,
c     &                PARDPR,PPRANK,INX,INY)
c          CALL MAKEBC(1,3,1,V,VELFL2,0.D0,OUTVAL,XDIST5,XDIST6,PARINT,
c     &                PARDPR,PPRANK,INX,INY)
c	ENDIF
      ENDIF
C.... Getting a value over all the inlet boundary.
      CALL MPI_ALLREDUCE(OUTF11,TMPFL1,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     &                   COMM2D,IERR00)
      OFLUS1 = TMPFL1
c      WRITE(*,*)'OFLUS LIQ = ',OFLUS1
      TMPFL1 = 0.D0
      CALL MPI_ALLREDUCE(OUTF21,TMPFL1,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     &                   COMM2D,IERR00)
c      WRITE(*,*)'OFLUS GAS = ',TMPFL1
      OFLUS1 = OFLUS1 + TMPFL1
c      WRITE(*,*)'OFLUS TOTAL = ',OFLUS1
C.... North boundary.
      OUTF00 = 0.D0
      IF(NEIGHB(1).LT.0) THEN
        CALL MAKEBC(3,1,0,V,0.D0,1.D0,OUTF00,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
      TMPFL1 = 0.D0
      CALL MPI_ALLREDUCE(OUTF00,TMPFL1,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     &                   COMM2D,IERR00)
c      WRITE(*,*)'OUT TOTAL = ',TMPFL1
      OFLUS2 = OFLUS1 - TMPFL1
c      WRITE(*,*)'OFLUS2 = ',OFLUS2
      IF(NEIGHB(1).LT.0) THEN
c        WRITE(6,*)'RANK= ',PPRANK,' OUTLET AT NORTH'
	CALL MAKEBC(3,1,0,U,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        IF(T.EQ.0) THEN
          CALL MAKEBC(2,1,0,V,OFLUS1,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &                PARDPR,PPRANK,INX,INY)
        ELSE
          CALL MAKEBC(2,1,0,V,OFLUS2,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &                PARDPR,PPRANK,INX,INY)
        ENDIF
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
c        WRITE(6,*)'RANK= ',PPRANK,' ZERO FLUX AT EAST'
	CALL MAKEBC(3,2,0,U,0.D0,0.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(4,2,0,V,0.D0,1.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
c        WRITE(6,*)'RANK= ',PPRANK,' ZERO FLUX AT WEST'
	CALL MAKEBC(3,4,0,U,0.D0,0.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,4,1,U,0.D0,0.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(4,4,0,V,0.D0,1.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
        U(1,1) = 0.D0
	V(1,1) = V(2,1)
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
        U(INX,1) = 0.D0
	V(INX,1) = V(INX-1,1)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
        U(INX,INY) = 0.D0
	V(INX,INY) = V(INX-1,INY)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
        U(1,INY) = 0.D0
	V(1,INY) = V(2,INY)
      ENDIF
C
      RETURN
      END
C******************************************************************************
      SUBROUTINE MAKEBCC(C,PARINT,PARDPR,INX,INY)
C
C     Author: Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the CC array
C     Purpose: To define the type and place of boundary conditions.
C     Called by: ciam-raus & time_step
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INTEGER NEIGHB(8),PARINT(100),INX,INY,
     &        PPRANK,INDIXF,INDIXL,INDIYF,INDIYL,INDI01
      DOUBLE PRECISION PARDPR(100),OUTVAL,ROUTF1,ROUTF2,SOLID1,
     &                 XIPROC,XFPROC,
     &                 YIPROC,YFPROC,XDIST1,XDIST2,XDIST3,XDIST4,
     &                 XDIST5,XDIST6
      DOUBLE PRECISION C(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'MAKEBCC'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
      OUTVAL = 0.D0
      XDIST1 = -1.D0
      XDIST2 = 0.D0
      XDIST3 = 0.D0
      XDIST4 = 0.D0
      XDIST5 = -1.D0
      XDIST6 = 0.D0
      ROUTF1 = PARDPR(6)
      SOLID1 = PARDPR(7) + ROUTF1
      ROUTF2 = PARDPR(8) + SOLID1
      XIPROC = PARDPR(54)
      XFPROC = PARDPR(54) + PARDPR(52)
      YIPROC = PARDPR(55)
      YFPROC = PARDPR(55) + PARDPR(53)
      IF (XIPROC.LT.ROUTF1) THEN
        XDIST1 = XIPROC
	IF (XFPROC.LE.ROUTF1) THEN
	  XDIST2 = XFPROC
	ELSEIF (XFPROC.LE.SOLID1) THEN
	  XDIST2 = ROUTF1
	ELSEIF (XFPROC.LE.ROUTF2) THEN
	  XDIST2 = ROUTF1
	  XDIST5 = SOLID1
	  XDIST6 = XFPROC
        ELSE
	  XDIST2 = ROUTF1
	  XDIST5 = SOLID1
	  XDIST6 = ROUTF2
	ENDIF
      ELSEIF (XIPROC.LT.SOLID1) THEN
	XDIST1 = -1.D0
	IF (XFPROC.LE.SOLID1) THEN
	  XDIST5 = -1.D0
	ELSEIF (XFPROC.LE.ROUTF2) THEN
          XDIST5 = SOLID1
	  XDIST6 = XFPROC
	ELSE
	  XDIST5 = SOLID1
	  XDIST6 = ROUTF2
	ENDIF
      ELSEIF (XIPROC.LT.ROUTF2) THEN
        XDIST5 = XIPROC
        IF (XFPROC.LE.ROUTF2) THEN
	  XDIST6 = XFPROC
	ELSE
	  XDIST6 = ROUTF2
	ENDIF
      ENDIF
c      WRITE(6,*)'RANK= ',PPRANK,' ROUTF1 = ',ROUTF1
c      WRITE(6,*)'RANK= ',PPRANK,' SOLID1 = ',SOLID1
c      WRITE(6,*)'RANK= ',PPRANK,' ROUTF2 = ',ROUTF2
c      WRITE(6,*)'RANK= ',PPRANK,' XIPROC = ',XIPROC
c      WRITE(6,*)'RANK= ',PPRANK,' XFPROC = ',XFPROC
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST1 = ',XDIST1
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST2 = ',XDIST2
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST3 = ',XDIST3
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST4 = ',XDIST4
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST5 = ',XDIST5
c      WRITE(6,*)'RANK= ',PPRANK,' XDIST6 = ',XDIST6
C
C.... Start from South boundary (usually the more complex BC).
      IF(NEIGHB(5).LT.0) THEN
C.... Basic boundary condition.
c	WRITE(6,*)'RANK= ',PPRANK,' BC AT SOUTH'
        CALL MAKEBC(3,3,0,C,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,3,1,C,0.D0,0.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
C.... Inlet of Fluid 1.
	IF(XDIST1.GE.0.D0) THEN
c	  WRITE(6,*)'RANK= ',PPRANK,' LIQUID INLET AT SOUTH'
          CALL MAKEBC(3,3,0,C,1.D0,0.D0,OUTVAL,XDIST1,XDIST2,PARINT,
     &                PARDPR,PPRANK,INX,INY)
          CALL MAKEBC(3,3,1,C,1.D0,0.D0,OUTVAL,XDIST1,XDIST2,PARINT,
     &                PARDPR,PPRANK,INX,INY)
	ENDIF
      ENDIF
C.... North boundary.
      IF(NEIGHB(1).LT.0) THEN
C        WRITE(6,*)'RANK= ',PPRANK,' OUTLET AT NORTH'
        CALL MAKEBC(4,1,0,C,0.D0,1.D0,OUTVAL,XIPROC,XFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
C        WRITE(6,*)'RANK= ',PPRANK,' ZERO FLUX AT EAST'
        CALL MAKEBC(4,2,0,C,0.D0,1.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
C        WRITE(6,*)'RANK= ',PPRANK,' ZERO FLUX AT WEST'
        CALL MAKEBC(4,4,0,C,0.D0,1.D0,OUTVAL,YIPROC,YFPROC,PARINT,
     &              PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
	C(1,1) = C(2,1)
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
	C(INX,1) = C(INX-1,1)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
	C(INX,INY) = C(INX-1,INY)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
	C(1,INY) = C(2,INY)
      ENDIF
C
      RETURN
      END
C******************************************************************************
      SUBROUTINE MAKEBCFLUX(FLXP,FLXM,FLZP,FLZM,PARINT,PARDPR,INX,INY)
C
C     Author: Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the FLUXes
C     Purpose: To define the type and place of boundary conditions.
C     Called by: ciam_raus
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INTEGER NEIGHB(8),PARINT(100),INX,INY,PPRANK,INDI01
      DOUBLE PRECISION PARDPR(100),PCOORS(4),OUTVAL
      DOUBLE PRECISION FLXM(INX,INY),FLXP(INX,INY)
      DOUBLE PRECISION FLZM(INX,INY),FLZP(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'MAKEBCFLUX'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
C
      PCOORS(1) = PARDPR(54)
      PCOORS(2) = PARDPR(54) + PARDPR(52)
      PCOORS(3) = PARDPR(55)
      PCOORS(4) = PARDPR(55) + PARDPR(53)
C
C.... South boundary.
      IF(NEIGHB(5).LT.0) THEN
        CALL MAKEBC(4,3,0,FLZP,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... North boundary.
      IF(NEIGHB(1).LT.0) THEN
        CALL MAKEBC(4,1,0,FLZM,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
        CALL MAKEBC(4,2,0,FLXM,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
        CALL MAKEBC(4,4,0,FLXP,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
	FLXP(1,1) = 0.D0
        FLXM(1,1) = 0.D0
	FLZP(1,1) = 0.D0
	FLZM(1,1) = 0.D0
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
        FLXP(INX,1) = 0.D0
	FLXM(INX,1) = 0.D0
	FLZP(INX,1) = 0.D0
	FLZM(INX,1) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
        FLXP(INX,INY) = 0.D0
	FLXM(INX,INY) = 0.D0
	FLZP(INX,INY) = 0.D0
	FLZM(INX,INY) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
        FLXP(1,INY) = 0.D0
	FLXM(1,INY) = 0.D0
	FLZP(1,INY) = 0.D0
	FLZM(1,INY) = 0.D0
      ENDIF
C
      RETURN
      END
C******************************************************************************
      SUBROUTINE MAKEBCS(S,PARINT,PARDPR,INX,INY)
C
C     Author: Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the S arrays
C     Purpose: To define the type and place of boundary conditions.
C     Called by: momentum
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INTEGER NEIGHB(8),PARINT(100),INX,INY,PPRANK,INDI01
      DOUBLE PRECISION PARDPR(100),PCOORS(4),OUTVAL
      DOUBLE PRECISION S(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'MAKEBCS'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
C
      PCOORS(1) = PARDPR(54)
      PCOORS(2) = PARDPR(54) + PARDPR(52)
      PCOORS(3) = PARDPR(55)
      PCOORS(4) = PARDPR(55) + PARDPR(53)
C
C.... South boundary.
      IF(NEIGHB(5).LT.0) THEN
        CALL MAKEBC(3,3,0,S,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,3,1,S,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... North boundary.
      IF(NEIGHB(1).LT.0) THEN
        CALL MAKEBC(3,1,0,S,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
        CALL MAKEBC(3,2,0,S,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
        CALL MAKEBC(3,4,0,S,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
        CALL MAKEBC(3,4,1,S,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
	S(1,1) = 0.D0
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
        S(INX,1) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
        S(INX,INY) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
        S(1,INY) = 0.D0
      ENDIF
C
      RETURN
      END
C******************************************************************************
      SUBROUTINE MAKEBCRESF(RES,PARINT,PARDPR,INX,INY)
C
C     Author: Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the RESidual arrays
C     Purpose: To define the type and place of boundary conditions.
C     Called by: mglin
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INTEGER NEIGHB(8),PARINT(100),INX,INY,PPRANK,INDI01
      DOUBLE PRECISION PARDPR(100),PCOORS(4),OUTVAL
      DOUBLE PRECISION RES(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'MAKEBCRES'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
C
      PCOORS(1) = PARDPR(54)
      PCOORS(2) = PARDPR(54) + PARDPR(52)
      PCOORS(3) = PARDPR(55)
      PCOORS(4) = PARDPR(55) + PARDPR(53)
C
C.... South boundary.
      IF(NEIGHB(5).LT.0) THEN
        CALL MAKEBC(3,3,0,RES,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... North boundary.
      IF(NEIGHB(1).LT.0) THEN
        CALL MAKEBC(3,1,0,RES,0.D0,0.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
        CALL MAKEBC(3,2,0,RES,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
        CALL MAKEBC(3,4,0,RES,0.D0,0.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
	RES(1,1) = 0.D0
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
        RES(INX,1) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
        RES(INX,INY) = 0.D0
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
        RES(1,INY) = 0.D0
      ENDIF
C
      RETURN
      END
C******************************************************************************
      SUBROUTINE MAKEBCPF(P,PARINT,PARDPR,INX,INY)
C
C     Author: Anthony Leboissetier
C     Name: MAKE Boundary Conditions for the Pressure calculations
C     Purpose: To define the type and place of boundary conditions.
C     Called by: mglin
C     It calls: MAKEBC
C     Modifications:
C
      IMPLICIT NONE
      INTEGER NEIGHB(8),PARINT(100),INX,INY,PPRANK,INDI01
      DOUBLE PRECISION PARDPR(100),PCOORS(4),OUTVAL
      DOUBLE PRECISION P(INX,INY)
      CHARACTER*6 NAMSUB
C.... Preliminaries
      NAMSUB = 'MAKEBCP'
      PPRANK = PARINT(55)
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60+INDI01)
      ENDDO
C
      PCOORS(1) = PARDPR(54)
      PCOORS(2) = PARDPR(54) + PARDPR(52)
      PCOORS(3) = PARDPR(55)
      PCOORS(4) = PARDPR(55) + PARDPR(53)
C
C.... South boundary.
      IF(NEIGHB(5).LT.0) THEN
        CALL MAKEBC(4,3,0,P,0.D0,1.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... North boundary.
      IF(NEIGHB(1).LT.0) THEN
        CALL MAKEBC(4,1,0,P,0.D0,1.D0,OUTVAL,PCOORS(1),PCOORS(2),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... East boundary.
      IF(NEIGHB(3).LT.0) THEN
        CALL MAKEBC(4,2,0,P,0.D0,1.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... West boundary.
      IF(NEIGHB(7).LT.0) THEN
        CALL MAKEBC(4,4,0,P,0.D0,1.D0,OUTVAL,PCOORS(3),PCOORS(4),
     &              PARINT,PARDPR,PPRANK,INX,INY)
      ENDIF
C.... The 4 corners
      IF(NEIGHB(5).LT.0.AND.NEIGHB(7).LT.0) THEN
	P(1,1) = P(1,2)
      ENDIF
      IF(NEIGHB(5).LT.0.AND.NEIGHB(3).LT.0) THEN
        P(INX,1) = P(INX-1,1)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(3).LT.0) THEN
        P(INX,INY) = P(INX-1,INY)
      ENDIF
      IF(NEIGHB(1).LT.0.AND.NEIGHB(7).LT.0) THEN
        P(1,INY) = P(2,INY)
      ENDIF
C
      RETURN
      END
